<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="试题类型" prop="tqueType">
        <el-select v-model="queryParams.tqueType" placeholder="请选择试题类型" clearable>
          <el-option v-for="dict in ttsa_tque_type" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="试题等级" prop="tqueGrad">
        <el-select v-model="queryParams.tqueGrad" placeholder="请选择试题等级" clearable>
          <el-option label="A" value="A" />
          <el-option label="B" value="B" />
          <el-option label="C" value="C" />
          <el-option label="D" value="D" />
        </el-select>
      </el-form-item>
      <el-form-item label="试题标题" prop="tqueTitl">
        <el-input v-model="queryParams.tqueTitl" placeholder="请输入试题标题" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['ttsa:ttsatque:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['ttsa:ttsatque:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['ttsa:ttsatque:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['ttsa:ttsatque:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="ttsa-ttsatque-index"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="试题类型" prop="tqueType">
        <template #default="scope">
          <dict-tag :options="ttsa_tque_type" :value="scope.row.tqueType" />
        </template>
      </el-table-column>
      <el-table-column label="题目类型" prop="queType" />
      <el-table-column label="试题等级" prop="tqueGrad" />
      <el-table-column label="试题标题" prop="tqueTitl" />
      <el-table-column label="试题答案" prop="tqueAnsw" />
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['ttsa:ttsatque:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['ttsa:ttsatque:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="600px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="试题类型" prop="tqueType">
          <el-select v-model="form.tqueType" placeholder="请选择试题类型">
            <el-option v-for="dict in ttsa_tque_type" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="题目类型" prop="queType">
          <el-input v-model="form.queType" placeholder="请输入题目类型" />
        </el-form-item>
        <el-form-item label="试题等级" prop="tqueGrad">
          <el-input v-model="form.tqueGrad" placeholder="请输入试题等级" />
        </el-form-item>
        <el-form-item label="试题标题" prop="tqueTitl">
          <el-input v-model="form.tqueTitl" placeholder="请输入试题标题" />
        </el-form-item>
        <el-form-item label="试题答案" prop="tqueAnsw">
          <el-input v-model="form.tqueAnsw" placeholder="请输入试题答案" />
        </el-form-item>
        <el-form-item label="适用类型" prop="applType">
          <el-input v-model="form.applType" placeholder="请输入适用类型" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="TtsaTque">
import { listBisTtsaTque, getBisTtsaTque, addBisTtsaTque, updateBisTtsaTque, delBisTtsaTque } from "@/api/slaj/ttsa";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();
const { ttsa_tque_type } = proxy.useDict("ttsa_tque_type");

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const columns = ref({ tqueType: { visible: true }, queType: { visible: true }, tqueGrad: { visible: true }, tqueTitl: { visible: true }, tqueAnsw: { visible: true } });

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, tqueType: null, tqueGrad: null, tqueTitl: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listBisTtsaTque(queryParams.value).then(r => {
    dataList.value = r.rows;
    total.value = r.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(s) {
  ids.value = s.map(i => i.guid);
  single.value = s.length !== 1;
  multiple.value = !s.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加试题";
}

function handleUpdate(row) {
  reset();
  getBisTtsaTque(row.guid || ids.value[0]).then(r => {
    form.value = r.data;
    open.value = true;
    title.value = "修改试题";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(v => {
    if (v) {
      if (form.value.guid != null) {
        updateBisTtsaTque(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBisTtsaTque(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('确认删除？').then(() => delBisTtsaTque(row.guid || ids.value.join(","))).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/ttsa/ttsatque/export', { ...queryParams.value }, `试题_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { guid: null, tqueType: null, queType: null, tqueGrad: null, tqueTitl: null, tqueAnsw: null, applType: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
